#include <cassert>
#include <string>
#include <ctime>
#include <iostream>
#include "mex.h"


using std::cout;
using std::endl;


void err_chk(cudaError err) {
  if (err != cudaSuccess) {
    cout << cudaGetErrorString(err) << endl;
    assert(false);
  }
}

__constant__ float c_arr[10];


__global__ void test_kernel (float* d_arr) {


  int ii = blockDim.x*blockIdx.x + threadIdx.x;
  d_arr[ii] = c_arr[ii];
}


class mystream : public std::streambuf
{
protected:
virtual std::streamsize xsputn(const char *s, std::streamsize n) { mexPrintf("%.*s", n, s); return n; }
virtual int overflow(int c=EOF) { if (c != EOF) { mexPrintf("%.1s", &c); } return 1; }
};
class scoped_redirect_cout
{
public:
	scoped_redirect_cout() { old_buf = std::cout.rdbuf(); std::cout.rdbuf(&mout); }
	~scoped_redirect_cout() { std::cout.rdbuf(old_buf); }
private:
	mystream mout;
	std::streambuf *old_buf;
};
static scoped_redirect_cout mycout_redirect;





void mexFunction(int nlhs, mxArray *plhs[], int nrhs, mxArray const *prhs[]) {

  float* h_arr = new float[10];
  for (int i=0; i<10; i++) {
    h_arr[i] = i;
  }
  err_chk(cudaMemcpyToSymbol (c_arr, h_arr, sizeof(float)*10));

cout << "point 1" << endl;
  float* d_arr;
  err_chk(cudaMalloc((void**)&d_arr, sizeof(float)*10));
cout << "point 2" << endl;
  
  test_kernel <<<1,10>>> (d_arr);
  cout << "got here?" << endl;
  float* l_arr = new float[10];
  err_chk(cudaMemcpy(l_arr, d_arr, sizeof(float)*10, cudaMemcpyDeviceToHost));
cout << "point 3" << endl;
  
  
  
  
  
  
  
  for (int i=0; i<10; i++) {
    cout << l_arr[i] << endl;
  }
  
  
  
  
  
  
  cudaFree(d_arr);
  delete[] l_arr;
  delete[] h_arr;
  
  
 
  
  
  
}




