%%

%To run this code,
%C:\Program Files\MATLAB\R2016b\toolbox\distcomp\gpu\extern\src\mex\win64\nvcc_msvcpp2015.xml
%go to ARCHFLAGS and delete -gencode=arch=compute_20,code=sm_20 
%%
cd C:\Users\hyong\Dropbox\papers\matrixOMT\test_cuda
mexcuda -g partial_mex.cu


%%
cd C:\Users\hyong\Dropbox\papers\matrixOMT\test_cuda
mexcuda -g unbalanced_mex.cu 

%%
n=128;

rho0 = double(255-rgb2gray(imread('./raw_images/text2_small.png')));
rho0 = rho0 + double(255-rgb2gray(imread('./raw_images/ink_splat2_small.png')));
rho0 = rho0 / sum(sum(rho0));


rho1 = double(255-rgb2gray(imread('./raw_images/text1_small.png')));
rho1 = rho1/sum(sum(rho1)) * 0.8;

gamma = 0.8;
options = partial_wass_options();
options.max_iter = 2.5e5;
[dist, m, Phi, t_rho0, t_rho1]=partial_wass(rho0, rho1,gamma,options);


%%
n=256;


rho0 = double(255-rgb2gray(imread('./raw_images/cat1.png')));
rho0 = rho0+ double(255-rgb2gray(imread('./raw_images/ink_splat.png')));
rho0 = rho0 / sum(sum(rho0));


rho1 = double(255-rgb2gray(imread('./raw_images/cat2.png')));
rho1 = rho1/sum(sum(rho1));


gamma = 0.2;
options = partial_wass_options();
options.max_iter = 1e3;
[dist, m, Phi, t_rho0, t_rho1]=partial_wass(rho0, rho1,gamma,options);
gamma
dist
%%

h = gcf;
print('bear_bear_2','-dpng','-r300')

%%
clear;
% n=32;
% max_iter = 0.5e5;
%n=64;
%max_iter = 1e5;
%n=128;
%max_iter = 2.5e5;
n=256;
max_iter = 5e5;
[XX,YY] = meshgrid(linspace(-2,2,n),linspace(-2,2,n));


%rho0 generator
rho0 = zeros(n,n);
II = (sqrt((XX).^2+(YY).^2)<0.2);
rho0(II) = 1;
II = (sqrt((XX).^2+(YY+1).^2)<0.2);
rho0(II) = 1;
rho0 = rho0 / sum(sum(rho0));


%rho1 generator
rho1 = zeros(n,n);
II = (sqrt((XX-1).^2+(YY-1).^2)<0.2);
rho1(II) = 1;
II = (sqrt((XX+1).^2+(YY-1).^2)<0.2);
rho1(II) = 1;
rho1 = rho1 / sum(sum(rho1));


gamma = 0.5;
options = partial_wass_options();
options.tau = 0.1;
[dist, m, Phi, t_rho0, t_rho1]=partial_wass(rho0, rho1,gamma,options);






%%

%m plotter
n=32;
mmx = zeros(32,32);
mmy = zeros(32,32);
for ii=1:32
    for jj=1:32
        for kk=1:1
            for ll=1:1
                mmx(ii,jj) = mmx(ii,jj) + m(1*(ii-1)+kk,1*(jj-1)+ll,1);
                mmy(ii,jj) = mmy(ii,jj) + m(1*(ii-1)+kk,1*(jj-1)+ll,2);
            end
        end
    end
end
I=zeros(n,n,3);
I(:,:,1) = I(:,:,1) + rho0/max(max(rho0))*50/255;
I(:,:,2) = I(:,:,2) + rho0/max(max(rho0))*132/255;
I(:,:,3) = I(:,:,3) + rho0/max(max(rho0))*191/255;
I(:,:,1) = I(:,:,1) + rho1/max(max(rho1))*255/255;
I(:,:,2) = I(:,:,2) + rho1/max(max(rho1))*232/255;
I(:,:,3) = I(:,:,3) + rho1/max(max(rho1))*0/255;
imagesc([-2,2],[-2,2],I);

hold on;
[XX,YY] = meshgrid(linspace(-2,2,32),linspace(-2,2,32));
%quiver(XX,YY,m(1:256,:),m((n+1):(2*n),:), 1)
quiver(XX,YY,mmy,mmx, 1,'color',[1, .3, .3])

daspect([max(daspect)*[1 1] 1])
pbaspect([1 1 1])

h=gca;
set(h,'XTick',[])
set(h,'YTick',[])

ax = gca;
ax.OuterPosition(3)=ax.OuterPosition(4);
outerpos = ax.OuterPosition;
ti = ax.TightInset; 
left = outerpos(1) + ti(1);
bottom = outerpos(2) + ti(2);
ax_width = outerpos(3) - ti(1) - ti(3);
ax_height = outerpos(4) - ti(2) - ti(4);
ax.Position = [left bottom ax_width ax_height];

%%

%m plotter
n=64;
mmx = zeros(32,32);
mmy = zeros(32,32);
for ii=1:32
    for jj=1:32
        for kk=1:2
            for ll=1:2
                mmx(ii,jj) = mmx(ii,jj) + m(2*(ii-1)+kk,2*(jj-1)+ll,1);
                mmy(ii,jj) = mmy(ii,jj) + m(2*(ii-1)+kk,2*(jj-1)+ll,2);
            end
        end
    end
end
I=zeros(n,n,3);
I(:,:,1) = I(:,:,1) + rho0/max(max(rho0))*50/255;
I(:,:,2) = I(:,:,2) + rho0/max(max(rho0))*132/255;
I(:,:,3) = I(:,:,3) + rho0/max(max(rho0))*191/255;
I(:,:,1) = I(:,:,1) + rho1/max(max(rho1))*255/255;
I(:,:,2) = I(:,:,2) + rho1/max(max(rho1))*232/255;
I(:,:,3) = I(:,:,3) + rho1/max(max(rho1))*0/255;
imagesc([-2,2],[-2,2],I);

hold on;
[XX,YY] = meshgrid(linspace(-2,2,32),linspace(-2,2,32));
%quiver(XX,YY,m(1:256,:),m((n+1):(2*n),:), 1)
quiver(XX,YY,mmy,mmx, 1,'color',[1, .3, .3])

daspect([max(daspect)*[1 1] 1])
pbaspect([1 1 1])

h=gca;
set(h,'XTick',[])
set(h,'YTick',[])

ax = gca;
ax.OuterPosition(3)=ax.OuterPosition(4);
outerpos = ax.OuterPosition;
ti = ax.TightInset; 
left = outerpos(1) + ti(1);
bottom = outerpos(2) + ti(2);
ax_width = outerpos(3) - ti(1) - ti(3);
ax_height = outerpos(4) - ti(2) - ti(4);
ax.Position = [left bottom ax_width ax_height];

%%

I=zeros(n,n,3);
I(:,:,1) = I(:,:,1) + t_rho0/max(max(t_rho0))*50/255;
I(:,:,2) = I(:,:,2) + t_rho0/max(max(t_rho0))*132/255;
I(:,:,3) = I(:,:,3) + t_rho0/max(max(t_rho0))*191/255;
imagesc([0,1],[0,1],I);
daspect([max(daspect)*[1 1] 1])
pbaspect([1 1 1])

h=gca;
set(h,'XTick',[])
set(h,'YTick',[])

ax = gca;
ax.OuterPosition(3)=ax.OuterPosition(4);
outerpos = ax.OuterPosition;
ti = ax.TightInset; 
left = outerpos(1) + ti(1);
bottom = outerpos(2) + ti(2);
ax_width = outerpos(3) - ti(1) - ti(3);
ax_height = outerpos(4) - ti(2) - ti(4);
ax.Position = [left bottom ax_width ax_height];


%%

%m plotter
n=128;
mmx = zeros(32,32);
mmy = zeros(32,32);
for ii=1:32
    for jj=1:32
        for kk=1:4
            for ll=1:4
                mmx(ii,jj) = mmx(ii,jj) + m(4*(ii-1)+kk,4*(jj-1)+ll,1);
                mmy(ii,jj) = mmy(ii,jj) + m(4*(ii-1)+kk,4*(jj-1)+ll,2);
            end
        end
    end
end
I=zeros(n,n,3);
I(:,:,1) = I(:,:,1) + rho0/max(max(rho0))*50/255;
I(:,:,2) = I(:,:,2) + rho0/max(max(rho0))*132/255;
I(:,:,3) = I(:,:,3) + rho0/max(max(rho0))*191/255;
I(:,:,1) = I(:,:,1) + rho1/max(max(rho1))*255/255;
I(:,:,2) = I(:,:,2) + rho1/max(max(rho1))*232/255;
I(:,:,3) = I(:,:,3) + rho1/max(max(rho1))*0/255;
imagesc([-2,2],[-2,2],I);

hold on;
[XX,YY] = meshgrid(linspace(-2,2,32),linspace(-2,2,32));
%quiver(XX,YY,m(1:256,:),m((n+1):(2*n),:), 1)
quiver(XX,YY,mmy,mmx, 1,'color',[1, .3, .3])

daspect([max(daspect)*[1 1] 1])
pbaspect([1 1 1])

h=gca;
set(h,'XTick',[])
set(h,'YTick',[])

ax = gca;
ax.OuterPosition(3)=ax.OuterPosition(4);
outerpos = ax.OuterPosition;
ti = ax.TightInset; 
left = outerpos(1) + ti(1);
bottom = outerpos(2) + ti(2);
ax_width = outerpos(3) - ti(1) - ti(3);
ax_height = outerpos(4) - ti(2) - ti(4);
ax.Position = [left bottom ax_width ax_height];


%%

I=zeros(n,n,3);
I(:,:,1) = I(:,:,1) + t_rho0/max(max(t_rho0))*50/255;
I(:,:,2) = I(:,:,2) + t_rho0/max(max(t_rho0))*132/255;
I(:,:,3) = I(:,:,3) + t_rho0/max(max(t_rho0))*191/255;
imagesc([-2,2],[-2,2],I);


imagesc([-2,2],[-2,2],I);

hold on;
[XX,YY] = meshgrid(linspace(-2,2,32),linspace(-2,2,32));

daspect([max(daspect)*[1 1] 1])
pbaspect([1 1 1])

h=gca;
set(h,'XTick',[])
set(h,'YTick',[])

ax = gca;
ax.OuterPosition(3)=ax.OuterPosition(4);
outerpos = ax.OuterPosition;
ti = ax.TightInset; 
left = outerpos(1) + ti(1);
bottom = outerpos(2) + ti(2);
ax_width = outerpos(3) - ti(1) - ti(3);
ax_height = outerpos(4) - ti(2) - ti(4);
ax.Position = [left bottom ax_width ax_height];


%%

%m plotter
n=256;
mmx = zeros(32,32);
mmy = zeros(32,32);
for ii=1:32
    for jj=1:32
        for kk=1:8
            for ll=1:8
                mmx(ii,jj) = mmx(ii,jj) + m(8*(ii-1)+kk,8*(jj-1)+ll,1);
                mmy(ii,jj) = mmy(ii,jj) + m(8*(ii-1)+kk,8*(jj-1)+ll,2);
            end
        end
    end
end
I=zeros(n,n,3);
I(:,:,1) = I(:,:,1) + rho0/max(max(rho0))*50/255;
I(:,:,2) = I(:,:,2) + rho0/max(max(rho0))*132/255;
I(:,:,3) = I(:,:,3) + rho0/max(max(rho0))*191/255;
I(:,:,1) = I(:,:,1) + rho1/max(max(rho1))*255/255;
I(:,:,2) = I(:,:,2) + rho1/max(max(rho1))*232/255;
I(:,:,3) = I(:,:,3) + rho1/max(max(rho1))*0/255;
imagesc([-2,2],[-2,2],I);

hold on;
[XX,YY] = meshgrid(linspace(-2,2,32),linspace(-2,2,32));
%quiver(XX,YY,m(1:256,:),m((n+1):(2*n),:), 1)
quiver(XX,YY,mmy,mmx, 1,'color',[1, .3, .3])

daspect([max(daspect)*[1 1] 1])
pbaspect([1 1 1])

h=gca;
set(h,'XTick',[])
set(h,'YTick',[])

ax = gca;
ax.OuterPosition(3)=ax.OuterPosition(4);
outerpos = ax.OuterPosition;
ti = ax.TightInset; 
left = outerpos(1) + ti(1);
bottom = outerpos(2) + ti(2);
ax_width = outerpos(3) - ti(1) - ti(3);
ax_height = outerpos(4) - ti(2) - ti(4);
ax.Position = [left bottom ax_width ax_height];

